<?php

/**
 * @file
 * Helper functions for the Copyscape module.
 */

/**
 * Checks if the user with the uid passed is bypassing the copyscape checks.
 *
 * @param object $user
 *   The user object to check against.
 *
 * @return bool
 *   TRUE if the user can bypass copyscape.
 */
function copyscape_user_bypass($user) {
  // The user with uid=1 bypasses copyscape.
  if ($user->uid === '1') {
    return TRUE;
  }

  // Check in bypass users list.
  $uid_list = explode("\n", variable_get('copyscape_uids_bypass', ''));
  if (in_array($user->uid, $uid_list)) {
    return TRUE;
  }

  // Check in bypass roles list.
  $rid_list = variable_get('copyscape_rids_bypass', array());
  foreach ($rid_list as $rid => $value) {
    if ($value === 0) {
      continue;
    }

    if (isset($user->roles[$rid])) {
      return TRUE;
    }
  }

  // The user is not bypassing the copyscape verification.
  return FALSE;
}
